;|----------------------------------------------|
;|    OTRONA DISK BACKUP UTILITY VERS. 1.7	|
;|	    FILE: BACKUP.ASM			|
;|     COPYRIGHT by OTRONA CORP. (C) 1982	|
;|----------------------------------------------|
;|						|
;|	  by STEVE GRAY 10-03-82		|
;|						|	
;|----------------------------------------------|
;
	.PABS
	.PHEX
	.LOC	100H
	.LIST
;
;          DEFINITIONS
;
CONIN	=	6
CONOUT	=	9
EXMOF	=	54H
DISKOF	=	11H
DSKFLG	=	0DA82H
CTRLC	=	3
ESC	=	1BH
;
FORMAT	=	1
WRITE	=	2
READ	=	3
;
;          MAIN PROGRAM
;
;|--------------------------------------|
;| 	SET UP STACK AND VECTORS	|
;|--------------------------------------|

BACKUP:	SSPD	TEMSTK
	LXI	SP,STACK
	LHLD	1
	LXI	D,EXMOF
	DAD	D
;
	MOV	A,M	; TEST FOR 96 0R 48 TPI
	ORA	A
	MVI	A,76
	JRNZ	..J1
	MVI	A,156
..J1:	STA	DELTA1+1
	MVI	A,40
	JRNZ	..J2
	MVI	A,80
..J2:	STA	DELTA2+1
	STA	DELTA3+1
;
	LXI	D,DISKOF
	DAD	D
	SHLD	DISK+1
	LXI	D,1AH
	DAD	D
	SHLD	FLG1+1
	SHLD 	FLG2+1
	SHLD	FLG3+1
	SHLD	FLG4+1	
	SHLD	FLG5+1
	LHLD	1
	LXI	D,CONIN
	DAD	D
	SHLD	COIN+1
	LXI	D,3
	DAD	D
	SHLD	COUT+1
	LXI	H,SIGNON
	CALL	MESSG
;
;|------------------------------|
;|	CHECK COMMAND TAIL	|
;|------------------------------|
;
	LXI	H,FMTFLG
	MVI	M,0	; CLEAR FORMAT FLAG
	LDA	80H
	ORA	A	; IF NO COMMAND TAIL
	JRZ	REBACK	; THEN CONTINUE
	LDA	82H	; ELSE
	CPI	"F"	; IF COMMAND = F
	JRNZ	REBACK
	MOV	M,A	; THEN FORCE FORMAT
;
REBACK:	LXI	SP,STACK
	LXI	H,STATUS
	CALL	MESSG
	LXI	H,PROMPT
	CALL	MESSG
	CALL	COIN
	CPI	CTRLC
	JZ	EXIT
	CPI	ESC
	JZ	EXIT
	LXI	H,FMTFLG
	ANI	0DFH
	CPI	"F"
	JRNZ	..CHK	
	MOV	M,A	; FORCE FORMAT
	JMPR	..NOFM
..CHK:	CPI	"C"
	JRZ	..DOCK	; FORCE A CHECK
	MOV	A,M	; IF FORMAT FLAG PREVIOUSLY SET
	ORA	A	;  TO FORMAT,
	JRNZ	..NOFM	;  THEN CONTINUE TO DO SO
;
..DOCK:	CALL	CHKFMT
..NOFM:	CALL	COPY
	JMPR	SYSOVR
;
ERROR:	XRA	A
FLG5:	STA	DSKFLG
	POP	B
	POP	B
	LXI	H,POSCUR
	CALL	MESSG
	MVI	A,9
	CALL	DISK
	JMPR	ERR2
CMPERR:	LXI	H,POSCUR
	CALL	MESSG
	LXI	H,BADCMP
	CALL	MESSG
ERR2:	LXI	H,ERRMSG
	CALL	MESSG
ERR3:	CALL	COIN
	ANI	0DFH
	CPI	"R"
	JRZ	RECOP1 	
	CPI	ESC
	JZ	EXIT
	CPI	"B"
	JZ	REBACK
	CPI	CTRLC
	JZ	EXIT
	JMPR	ERR3
;
RECOP1:	LXI	H,POS2
	CALL	MESSG
	POP	D
	POP	H
	POP	B
	JMPR	RECOPY
;
SYSOVR:	LXI	H,AGAIN
	CALL	MESSG
..SL1:	CALL	COIN
	ANI	0DFH
	CPI	'Y'
	JZ	REBACK
	CPI	'N'
	JZ	EXIT
	CPI	CTRLC
	JZ	EXIT
	JMPR	..SL1
;
;|--------------------------------------|
;|   CHECK FOR DISK ALREADY FORMATTED	|	
;|--------------------------------------|
;
CHKFMT:	LXI	H,TEST
	CALL	MESSG
	LXI	H,CPMIMG
	LXI	D,301H
	LXI	B,101H
	MVI	A,READ
	PUSH	PSW
	XRA	A	
	STA	FMTFLG
	MVI	A,10	; SEE IF DISK IS READABLE
L10:	STA	TRIES
	MVI	A,0FFH
FLG3:	STA	DSKFLG
	POP	PSW
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	CALL	DISK
..L1:	XRA	A
	CALL	DISK
	ORA	A	; IF DISK READ OK
	JRZ	..COP1	;  THEN START COPY W/O FORMAT
	ANI	0E0H
	JRZ	..L1
	LDA	TRIES	; ERROR ENCOUNTERED
	DCR	A
	POP	H
	POP	D
	POP	B
	JRNZ	L10
	POP	PSW
	STA	FMTFLG
	RET
..COP1:	POP	H
	POP	D
	POP	B
	POP	PSW
	RET
;
;|----------------------|
;|	BACKUP DISK	|
;|----------------------|
;
COPY:	XRA	A
FLG4:	STA	DSKFLG
	CALL	CLRTBL
	LXI	D,1
	MVI	A,1
	STA	TRKLMT
DELTA1:	MVI	B,76	; -- 156 FOR 96 TPI --
;
RECOPY:	PUSH	B
	LXI	H,CPMIMG
	PUSH	H
	PUSH	D
;
;
	LDA	FMTFLG
	ORA	A
	JRZ	..RC1
;
	LXI	H,FMB
	CALL	MESSG
	POP	D
	POP	H
	PUSH	H
	PUSH	D
	LXI	H,FMTBL
	CALL	FMCPMB
;
;
..RC1:	LXI	H,INA
	CALL	MESSG
	POP	D
 	POP	H
	PUSH	H
	PUSH	D
	CALL	RDCPM0
;
;
	LXI	H,OUTB
	CALL	MESSG
	POP	D
	POP	H
	PUSH	H
	PUSH	D
	CALL	WTCPM1
;
;
	LXI	H,INB
	CALL	MESSG
	POP	D
	POP	H
	LXI	H,DSKIMG
	PUSH	H
	PUSH	D
	CALL	RDCPM1
;
;
	LXI	H,BADCMP
	SHLD	CURMSG
	LXI	B,10*512
	LXI	D,CPMIMG
	LXI	H,DSKIMG
;
..TSL:	XCHG		;COMPARE IMAGES
	MOV	A,M
	XCHG
	INX	D
	CCI
	JPO	..J2	;CONTINUE IF DONE COMPARE
	JRZ	..TSL	;COMPARE AGAIN IF OK
	JMP	CMPERR	;JMP ERROR IF BAD COMPARE
;
..J2:	LDA	TRKLMT
DELTA2:	CPI	40	; -- 80 FOR 96 TPI --
	JRNZ	..J1
	CALL	CLRTBL
	CALL	INCHED
	MVI	A,80H
	JMPR	..J3
..J1:	PUSH	PSW	;INCREMENT FORMAT CYLINDER
	CALL	INCCYL
	POP	PSW
..J3:	POP	D
	POP	H
	MOV	D,A
	INR	A
	STA	TRKLMT
	POP	B
	DCR	B
	JNZ	RECOPY
	RET
;
;
FMCPMB:	MVI	A,FORMAT
	MVI	C,1
	JMPR	RWCPM
;
RDCPM0:	MVI	A,READ
	MVI	C,0
	JMPR	RWCPM
;
WTCPM1:	MVI	A,WRITE
	MVI	C,1
	JMPR	RWCPM
;
RDCPM1:	MVI	A,READ
	MVI	C,1
;
;
RWCPM:	MOV	B,A
	MVI	A,10
	STA	TRIES
	MOV	A,B
	MVI	B,1
	MVI	E,1
RWONE:	PUSH	PSW
	MVI	A,0FFH
FLG1:	STA	DSKFLG
	POP	PSW
	CALL	UPSTAT
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	CALL	DISK
RL2:	PUSH	B
	CALL	DLY2MS
	POP	B
	XRA	A
DSK2:	CALL	DISK
	ORA	A
	JRZ	RJ1
	ANI	0E0H
	JRZ	RL2
	LDA	TRIES
	DCR	A
	STA	TRIES
	POP	H
	POP	D
	POP	B
	JZ	ERROR
	POP	PSW
	JMPR	RWONE
;
RJ1:	XRA	A
FLG2:	STA	DSKFLG
	MVI	A,10
	STA 	TRIES
	POP	H
	POP	D
	POP	B
	INR	H
	INR	H
	MOV	A,E
	CPI	10
	JRNZ	RJ2
	INR	D
	MVI	E,0
RJ2:	INR	E
	LDA	TRKLMT
	CMP	D
	JRZ	RWOVER
	POP	PSW
	CPI	1
	RZ
	JMPR	RWONE
;
RWOVER:	POP	PSW
	RET
;
INCHED:	LXI	H,FMTBL+1
	JMPR	DOINC
INCCYL:	LXI	H,FMTBL
DOINC:	MVI	B,10
..L1:	INR	M
	LXI	D,4
	DAD	D
	DJNZ	..L1
	RET
;
CLRTBL:	LXI	H,FMTBL
	MVI	B,10
..L1:	MVI	M,0
	INX	H
	MVI	M,0
	LXI	D,3
	DAD	D
	DJNZ	..L1
	RET
;
UPSTAT:	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LDA	LSTTRK
	CMP	D
	JRZ	..J1
	MOV	A,D
	STA	LSTTRK
	CALL	CONVRT
	STA	TRKL	
	MOV	A,B
	STA	TRKM
;
	MOV	A,C
	STA	TRKC
;
	LXI	H,TRKUP
	PUSH	D
	CALL	MESSG
	POP	D
..J1:	MOV	A,E
	CALL	CONVRT
	STA	SECL
	MOV	A,B
	STA	SECM
	LXI	H,SECUP
	CALL	MESSG
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET
;
CONVRT:	LXI	B,3030H	
	BIT	7,A
	JRZ	L1
	INR	C
	ANI	7FH
DELTA3:	ADI	40	; -- 80 FOR 96 TPI --
	SUI	100
	JRNC	L1
	ADI	100
	DCR	C
L1:	SUI	0AH
	JM	..J1
	INR	B
	JMPR	L1
..J1:	ADI	3AH
	RET
;
MESSG:	MOV	C,M
	BIT 	7,C
	RES	7,C
	INX	H
	JNZ	COUT
	CALL	COUT	
	JMPR	MESSG
;
DLY2MS:	MVI	C,3
..L1:	MVI	B,0CDH
..L2:	DJNZ	..L2
	DCR	C
	JRNZ	..L1
	RET
;		
COUT:	JMP	0
;
COIN:	JMP	0
;
DISK:	JMP	0
;
EXIT:	LXI	H,PAROFF
	CALL	MESSG
	LSPD	TEMSTK
	RET
;
;		TABLES
;
PAROFF:	.BYTE	ESC,"d",ESC,"U",0A0H
;
SIGNON:	.BYTE	ESC,"\",ESC,"S","1"
	.ASCII	'      ATTACHE'
	.BYTE	ESC,"S","0",ESC,"U","0",74H,6DH,ESC,"U",20H
	.ASCII	'  DISK BACKUP UTILITY VERS. 1.7'	
	.BYTE	0DH,0AH
	.ASCII	'               COPYRIGHT 1982, OTRONA CORP., BOULDER, CO'
	.BYTE	0AH,0AH,0AH,0DH
	.ASCII	'        DISK WILL BE BACKED UP FROM DRIVE A: TO DRIVE B: BY TRACKS.'		
	.BYTE	0AH,0DH
	.ASCIS	"   DISK IN DRIVE B: WILL BE FORMATTED IF NECESSARY. COPY WILL BE VERIFIED."
;
PROMPT:	.BYTE	ESC,"d",ESC,"=",29H,20H,1BH,"J",0BH
	.ASCIS	'BACKUP >>'
;
BADCMP:	.BYTE	0AH,0DH
	.ASCIS	'BAD COMPARE.'
ERRMSG:	.BYTE 	0DH,0AH,0AH,ESC,"U",24H	
	.ASCIS	'OPTIONS: (R)ETRY, (W)ARM BOOT, (B)EGIN AGAIN'
AGAIN:	.BYTE	0AH,0DH,ESC,"d"
	.ASCIS	'BACKUP ANOTHER ? (Y or N) '
POSCUR:	.BYTE	ESC,"=",29H,20H,ESC,"K"+80H
POS1:	.BYTE	ESC,"=",2DH,20H,ESC,"J"+80H
POS2:	.BYTE	ESC,"=",29H,20H,ESC,"J",8BH
;
STATUS:	.BYTE	ESC,"=",28H,48H,ESC,"U",22H	
	.ASCII	' < WAITING >TRACK --- SECTOR -- '	
	.BYTE	ESC,"U",0A0H
;
TRKUP:	.BYTE	ESC,"c",ESC,"=",28H,5AH
	.BYTE	ESC,"U",22H
TRKC:	.BYTE	30H
TRKM:	.BYTE	30H
TRKL:	.BYTE	30H
 	.BYTE	ESC,"U",20H+80H
;		
SECUP:	.BYTE	ESC,"c",ESC,"=",28H,65H,ESC,"U",22H
SECM:	.BYTE	30H
SECL:	.BYTE	31H
	.BYTE	ESC,"U",20H+80H
;
INA:	.BYTE	ESC,"c",ESC,"=",28H,48H,ESC,"U",22H
	.ASCII	' READING:   '
	.BYTE	ESC,"U",20H+80H
;
OUTB:	.BYTE	ESC,"c",ESC,"=",28H,48H,ESC,"U",22H
	.ASCII	' WRITING:   '	
	.BYTE	ESC,"U",20H+80H
;
INB:	.BYTE	ESC,"c",ESC,"=",28H,48H,ESC,"U",22H
	.ASCII	' VERIFYING: '	
	.BYTE	ESC,"U",20H+80H
;
FMB:	.BYTE	ESC,"c",ESC,"=",28H,48H,ESC,"U",22H
	.ASCII	' FORMATTING:'	
	.BYTE	ESC,"U",20H+80H
;
TEST:	.BYTE	ESC,"c",ESC,"=",28H,48H,ESC,"U",22H
	.ASCII	' TESTING:   '	
	.BYTE	ESC,"U",20H+80H
;
FMTBL:	.BYTE	0,0,1,2,0,0,6,2
	.BYTE	0,0,2,2,0,0,7,2
	.BYTE	0,0,3,2,0,0,8,2
	.BYTE	0,0,4,2,0,0,9,2
	.BYTE	0,0,5,2,0,0,0AH,2
;
;	VARIABLES AND BUFFERS
;
LSTTRK:	.BYTE	0FFH
CURMSG:	.BLKW	1
TRIES:	.BLKB	1
TRKLMT:	.BLKB	1
CUROP:	.BLKW	1
FMTFLG:	.BLKB	1
TEMSTK:	.BLKW	1
;
	.LOC	1000H
STACK	=	.
CPMIMG:	.BLKB	10*512
DSKIMG:	.BLKB	10*512
;
	.XSYM
	.END
